#!/usr/local/bin/perl

##############################################################################
# PROGRAM : iLink Web Search Engine: Static Page Builder                     #
# VERSION : 2000.1.01                                                        #
#                                                                            #
##############################################################################
#                                                                            #
#             __                     __                                      #
#      __    /\ \       __          /\ \                                     #
#     /\_\   \ \ \     /\_\     ___ \ \ \/'\                                 #
#     \/\ \   \ \ \  __\/\ \  /' _ `\\ \ , <                                 #
#      \ \ \   \ \ \L\ \\ \ \ /\ \/\ \\ \ \\`\                               #
#       \ \_\   \ \____/ \ \_\\ \_\ \_\\ \_\ \_\                             #
#        \/_/    \/___/   \/_/ \/_/\/_/ \/_/\/_/                             #
#                                                                            #     
#                                     ___      __      __      __            #
#                                   /'___`\  /'__`\  /'__`\  /'__`\          #
#                                  /\_\ /\ \/\ \/\ \/\ \/\ \/\ \/\ \         #
#                                  \/_/// /_\ \ \ \ \ \ \ \ \ \ \ \ \        #
#                                     // /_\ \ \ \_\ \ \ \_\ \ \ \_\ \       #
#                                    /\______/\ \____/\ \____/\ \____/       #
#                                    \/_____/  \/___/  \/___/  \/___/        #
#                                                                            #
##############################################################################
# All source code, images, programs, files included in this distribution     #
# Copyright (c) 1996,1997,1998,1999,2000                                     #
#                                                                            #
#           John C. Cokos, The CCS Network, Inc.  IWeb, Inc.                 #
#           All Rights Reserved.                                             #
#                                                                            #
# Use, distibution, sale, or access to this program is forbidden without     #
# permission, except were permitted by the license agreement.                #
#                                                                            #
##############################################################################
#                                                                            #
#    ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------              #
#                                                                            #
#    Modification of the souce code of this program violates the             #
#    license agreement, and terminates your right to technical support.      #
#                                                                            #
##############################################################################

#START#

package IWEB;

BEGIN { 
   use Cwd;
}

BEGIN {
   $directory = cwd;
   $directory =~ s/\/admin//g;
   push @INC,$directory;
   push @INC,"."; 
   push @INC,"..";
}

BEGIN { 
   use IWeb::iweb; 
   use IWeb::ilink; 
}

   use vars qw(@categories @database);

   $BUILDING=1;
   $hyperseek{'Category'} = $input{'Category'};
   $hyperseek{'database'} = "$data_dir/ilink/hyperseek.dat";
   $hyperseek{'tempdb'} = "$data_dir/ilink/hyperseek.temp";
   $hyperseek{'catdb'} = "$data_dir/ilink/subcategories.dat";

   @categories=IWEB::Read_Categories();

   IWEB::Read_Language("ilink");
   IWEB::Read_Language("global");
   
   IWEB::build_ilink();


sub build_ilink {

   my($line,@cats_to_build,$ctb,$buildstart,$buildend);
   my($elapsed,$master_file,$master_html,$what_to_build);

   $PROG_URL = $urls{'ilink_url'};

   $MASTER = "<H1>$global{'Engine_Name'} File Map</H1>\n";

   if($global{'nph_headers'} eq "YES") { print "HTTP/1.0 200 OK\n"; }

   print "Content-Type: text/html\n\n";
   print "<FONT FACE=\"arial\" SIZE=-2>\n";
   print "<PRE>Building HTML Directory\n\n";
   print "Using the following settings:\n";
   print "   <B>Base Directory:</B> $global{'ILINK_DIR'}\n";
   print "   <B>Web Directory:</B> $global{'ILINK_VIRTUAL'}\n";
   print "   <B>File Type:</B> $global{'EXT'}\n";
   print "______________________________________________________________\n\n";

   $buildstart = time;

   IWEB::Home_Page();
   
   IWEB::BuildCats(); 

   $buildend = time;

   $elapsed = ($buildend - $buildstart) / 60;

   $master_html = "$global{'ILINK_VIRTUAL'}/enginemap.html";
   $master_file = "$global{'ILINK_DIR'}/enginemap.html";

   open(MASTER,">$master_file");
      print MASTER $MASTER;
   close(MASTER);

   print "<BR><H3>Master (map) created at: <A HREF=\"$master_html\">$master_file</A></H3>\n";
   print "<B><I>This</I></B> is the most important file.  You should submit this to the search engines, as it contains links\n";
   print "to every .html file we just created.  The engines will now definitely spider your <B>entire</B> directory !<BR><BR>\n";

   print "\n\n<CENTER><H1>Finished. ($elapsed Minutes Total Time)</H1>\n\n";


}



sub Home_Page {

   my($second,$second_page,$command);

   if (! -d $global{'ILINK_DIR'}) { mkdir($global{'ILINK_DIR'}, "777"); }
   chmod 0777, "$global{'ILINK_DIR'}";
   $out_file = "$global{'ILINK_DIR'}/index.$global{'ILINK_EXT'}";
   $MASTER .= "<A HREF=\"$global{'ILINK_VIRTUAL'}/index.$global{'ILINK_EXT'}\">Home Page</A><BR>\n";
   print "Home Page is at $out_file\n\n";

   $ENV{'QUERY_STRING'} = "";
   IWEB::Build();

}


sub BuildCats {


   my($BuildCategory,$bldpage,$idx,$bcat,$rnk,$c,%cats_to_build);

   ## Building, read it all in at once.
   open(DAT,"$hyperseek{'database'}");
     @database = <DAT>;
   close(DAT);
   

   $BuildCategory ="";

   for $c ( 0 .. $#categories ) {
     $BuildCategory = $categories[$c]{'Category'};
     $cats_to_build{$BuildCategory}++;
     if($categories[$c]{'SubCategory'}) { 
         $BuildCategory = "$categories[$c]{'Category'}:$categories[$c]{'SubCategory'}";
         $cats_to_build{$BuildCategory}++;
     }
   }

   foreach $bcat(sort keys %cats_to_build) {
       $done=0;
       $page=0;
       $idx='';
       $bldpage = IWEB::Make_Alpha($bcat);
       undef $next;
       until ($done==1) {
          if($page == 0) { $rnk=""; }
          else { $idx = "$page"; $rnk="&start=$hyperseek{'next'}"; }

          $out_file = "$global{'ILINK_DIR'}/$bldpage$idx.$global{'ILINK_EXT'}";

          $MASTER .= "<A HREF=\"$global{'ILINK_VIRTUAL'}/$bldpage.$global{'ILINK_EXT'}\">$bcat</A><BR>\n";
          print "Building Category Page at $out_file ($hyperseek{'remaining'})\n";

          $ENV{'QUERY_STRING'} = "search=CAT&Category=$bcat$rnk";
          &Build;
          $done = 1 if(! $hyperseek{'remaining'}>=1);
       }
    }

}


sub Build {


   undef %hyperseek;
   undef %HITS;
   undef %ignored;
   undef %category_matches;
   undef %forbidden;
   undef %descriptions;
   undef %catrelated;
   undef %metatitle;
   undef %metadesc;
   undef %metakeys;
   undef %score;
   undef %optional;
   undef %required;
   undef %screen;
   undef %categories;
   undef %counts;
   undef %teasers;
   undef %kept;

   undef @rows;
   undef @links;
   undef @Catsplit;
   undef @Count;

   undef $SQL;
   undef $COOKIE;
   undef $FONT1;
   undef $FONT2;
   undef $font1;
   undef $font2,
   undef $Remaining;
   undef $rank;
   undef $Next;
   undef $LINK_TEMPLATE;
   undef $Ignore;
   undef $d;
   undef $BR;
   undef $space;
   undef $http;
   undef $rate_votes_db;
   undef $rate_score_db;
   undef $database;
   undef $key_data;
   undef $cat_db;
   undef $new_db;
   undef $cool_db;
   undef $hits_db;
   undef $top10_db;

   undef $ID;
   undef $Category;
   undef $ELink;
   undef $Position;
   undef $Qualifier;
   undef $Email;
   undef $Title;
   undef $URL,
   undef $Description;
   undef $Keys;
   undef $desc_image;
   undef $title_tag;
   undef $site_icon;
   undef $Name;
   undef $Address;
   undef $City;
   undef $State;
   undef $Zip;
   undef $Country;
   undef $Phone;
   undef $Fax;
   undef $startdate;
   undef $enddate;
   undef $price;
   undef $account;
   undef $xfactor;
   undef $field1;
   undef $field2;
   undef $field3;
   undef $field4, 
   undef $field5;
   undef $field6;
   undef $field7;
   undef $field8;
   undef $field9;
   undef $field10;
   undef $OUT;

   %input=IWEB::parse_form("input");

   ## RESET ##
   $hyperseek{'Category'} = $input{'Category'};
   $hyperseek{'database'} = "$data_dir/ilink/hyperseek.dat";
   $hyperseek{'tempdb'} = "$data_dir/ilink/hyperseek.temp";
   $hyperseek{'catdb'} = "$data_dir/ilink/subcategories.dat";

    if(! $hyperseek{'Category'}) { $hyperseek{'directory'} = "T"; }
    # if ($hyperseek{'Category'}) { $hyperseek{'template'} = "$hyperseek{'Category'}"; }
    elsif ($hyperseek{'Category'}) { $hyperseek{'template'} = IWEB::Make_Alpha($hyperseek{'Category'}); }
    else { $hyperseek{'template'} = "ilink"; }

    IWEB::Page_Header($hyperseek{'template'});

}


sub BODY {
   my $body = IWEB::Category_Listings();
   return($body);
}


sub Read_Categories {

    my($sub_count,@tmp_subs,$rec,$tmp_subs,%tmp_subs,@sub_categories);

    open (CAT,"$hyperseek{'catdb'}");
      while ( <CAT> ) {
        $tmp_subs={};
        foreach $rec(split /\n/,join '',<CAT>){
 	  (undef,
	   @{$tmp_subs[$sub_count++]}{qw(Category SubCategory Count Teaser_Flag)})=split(/\|/,$rec,5);
        }
      }
    close (CAT);  

    @sub_categories = sort { $a->{'Category'} cmp $b->{'Category'} 
      or  $a->{'SubCategory'} cmp $b->{'SubCategory'} } @tmp_subs;

    return(@sub_categories);

}


sub Build_Matches {

    my($LINE,%res);

    foreach $LINE(@database) { 
         ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$LINE);

         if ( $Category  eq $hyperseek{'Category'} ) {
            if($URL) {
               $res{$Title} = qq! <A HREF="$URL" TARGET="$global{'ilink_target'}">$Title</A><BR>$Description<P>\n !;
            }
            else {
               $res{$Title} = qq! <LI><B>$Title</B><BR>$Description<P> !;
            }
            $hyperseek{'found'}++;
         }
     } 

     return(%res);

}
