#!/usr/local/bin/perl

package IWEB;

BEGIN { push @INC,".."; }

use IWeb::iweb;
use File::Copy;
use DB_File;

   IWEB::Read_Config();



   ## If you dont' have ilink in the same directory as hyperseek,
   ## Then, change these 2 values...

      $ilink_subcategories = "$data_dir/ilink/subcategories.dat";
      $ilink_database = "$data_dir/ilink/hyperseek.dat";


####################################################################

   print "Content-Type: text/html\n\n";
   print "<PRE>\n";

   IWEB::Convert_Categories();
   IWEB::Convert_Database();

   ## Final Permissions Check ##
   system("chmod -R 777 $data_dir");

   exit 0;



sub Convert_Categories {

  print "CONVERTING CATEGORIES\n";
  print "---------------------\n";

  tie %categories, "DB_File","$data_dir/hyperseek/categories/categories.db";
  tie %allcats, "DB_File","$data_dir/hyperseek/categories/master.db";
  tie %subcategories, "DB_File","$data_dir/hyperseek/categories/subcategories.db";
  tie %counts, "DB_File","$data_dir/hyperseek/categories/catcounts.db";
  tie %teasers, "DB_File","$data_dir/hyperseek/categories/teasers.db";
  ### Deep Subs ....
  print "Base: $ilink_subcategories\n";
  open (CAT,"$ilink_subcategories");
     foreach $line(<CAT>) {
        chomp($line);
        (undef,$cat,$sub,$count,$teaser_flag)=split(/\|/,$line);
        $full = "$cat:$sub";

        if($cat && $sub) {
           @entries=split(/\:/,$full);
           $num=$#entries;

           $del = quotemeta($entries[$num]);

           $parent=$full;
           $parent =~ s/\:$del//g;
       
           $child=$entries[$num];

           $subcategories{$parent} .= "$child|";

           $allcats{$full}++;

        }
        if($cat) { 
           $categories{$cat}++; 
           $allcats{$cat}++;
           print "Did: $cat\n";
        }
        $counts{$full} = $count if($cat);
        $counts{$cat}+=$count;
        $teasers{$cat} .= "$sub|" if($teaser_flag == 1);
     }
  close (CAT);  
  untie %subcategories;
  untie %counts;
  untie %teasers;
  untie %allcats;
  untie %categories;


  tie %related, "DB_File", "$data_dir/hyperseek/categories/related.db";
  tie %descriptions, "DB_File", "$data_dir/hyperseek/categories/descriptions.db";
  tie %titles, "DB_File", "$data_dir/hyperseek/categories/titles.db";
  tie %mkeys, "DB_File", "$data_dir/hyperseek/categories/mkeys.db";
  tie %mdesc, "DB_File", "$data_dir/hyperseek/categories/mdesc.db";
  ### Details.......
    open (DET,"$cat_detail");
      while ( <DET> ) {
	   ($crap,$dCat,$dRel,$dMod,$dModPW,$dM_Title,$dM_Desc,$dM_Keys,$dDesc)=split(/\|/,$_);
	   $descriptions{$dCat}=$dDesc;
           $dRel =~ s/\,/\|/g;
	   $related{$dCat}.="$dRel|";
	   $titles{$dCat}=$dM_Title;
	   $mkeys{$dCat}=$dM_Keys;
	   $mdesc{$dCat}=$dM_Desc;
      }
    close (DET);  

  untie %related;
  untie %descriptions;
  untie %titles;
  untie %mkeys;
  untie %mdesc;


  print "\nCategory Database disconnected.  Reconnecting to verify\n";

  print "Categories.db\n";
  tie %catmain, "DB_File","$data_dir/hyperseek/categories/categories.db";
    foreach $key (sort keys %catmain) { print "$key: $catmain{$key}\n"; }
  untie %catmain;

  print "\n\nMaster.db\n";
  tie %allcats, "DB_File","$data_dir/hyperseek/categories/master.db";
    foreach $key (sort keys %allcats) { print "$key: $allcats{$key}\n"; }
  untie %allcats;

  print "\n\nSubcategories.db\n";
  tie %subcategories, "DB_File","$data_dir/hyperseek/categories/subcategories.db";
    foreach $key (sort keys %subcategories) { print "$key: $subcategories{$key}\n"; }
  untie %categories;

  print "\n\nTeasers.db\n";
  tie %teasers, "DB_File","$data_dir/hyperseek/categories/teasers.db";
    foreach $key (sort keys %teasers) { print "$key: $teasers{$key}\n"; }
  untie %teasers;

  print "\n\nRelated.db\n";
  tie %related, "DB_File","$data_dir/hyperseek/categories/related.db";
    foreach $key (sort keys %related) { print "$key: $related{$key}\n"; }
  untie %related;

  print "CATEGORIES DONE";
  print "---------------------\n";

}


sub Convert_Database {

   my ($genid,$LINE,$x,$newline);

   print "Loading Data ... From $global{'DB_Format'} Database\n";
   print "---------------------------------------------------\n";

   if($global{'DB_Format'} eq "SQL") { 
      eval "use IWeb::sqlengine"; 
      IWEB::SQL_Connect();
   }
   elsif($global{'DB_Format'} eq "IWeb") { eval "use IWeb::dbmengine"; }

   print "Cleaning Up";

   if($global{'DB_Format'} eq "SQL") { 
      my $SQL1 = "DELETE FROM hyperseek_links";
      my $SQL2 = "DELETE FROM hyperseek_keys";
      my $SQL3 = "DELETE FROM hyperseek_cats";
      my $SQL4 = "DELETE FROM hyperseek_stats";
 
      $dbh->do($SQL1);
      $dbh->do($SQL2);
      $dbh->do($SQL3);
      $dbh->do($SQL4);
   }

   else { 
      unlink ("$data_dir/hyperseek/hyperseek.db");
      unlink ("$data_dir/hyperseek/cool.db");
      unlink ("$data_dir/hyperseek/new.db");

      system("rm -rf $data_dir/hyperseek/idx_cats");
      mkdir("$data_dir/hyperseek/idx_cats",0777);
      chmod 0777, "$data_dir/hyperseek/idx_cats";

      system("rm -rf $data_dir/hyperseek/idx_keys");
      mkdir("$data_dir/hyperseek/idx_keys",0777);
      chmod 0777, "$data_dir/hyperseek/idx_keys";
   }

   print " ... Done. Existing Data Deleted\n\n";


   $hyperseek{'loading'}=1;

   $genid=time;

    open (DB, "$ilink_database");
      while(<DB>) {
         chomp;
         if($_) {

            ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10) = split(/\|/,$_);

            next if($ID eq "id");
            if ( !($ID) ) { $ID = $genid; $genid++; }
            if ( !($Position) ) { $Position = 0; }


            $newline = "$ID|$Category|$ELink|$Position|$Qualifier|$Email|$Title|$URL|$Description|$Keys|$desc_image|$title_tag|$site_icon|$Name|$Address|$City|$State|$Zip|$Country|$Phone|$Fax|$startdate|$enddate|$price|$account|$xfactor|$field1|$field2|$field3|$field4|$field5|$field6|$field7|$field8|$field9|$field10";

            if($global{'DB_Format'} eq "SQL") { IWEB::SQL_Save_Entry($ID,$newline,1); }
            else { IWEB::DBM_Save_Entry($ID,$newline,1); }

            $x++;
            print "$x Loaded\n";
         }
      }
    close(DB);

    print "Main Database: [$loaded] Records Loaded into $global{'DB_Format'} Database\n";

}
